package;

class GameSession 
{
	// Passage of time
	public var year:Int;
	public var season:Int;
	
	// Permanent stats
	public var health:Int;
	public var strength:Int;
	public var wisdom:Int;
	public var charisma:Int;
	public var magic:Int;
	public var warfare:Int;
	public var cursed:Bool;
	
	// Permanent hidden stats
	public var ui:Int;
	public var ui_hide_shop:Int;
	public var mysticProgress:Int;
	public var totalAdventures:Int;
	public var killedTheBear:Bool;
	public var foundWizardTower:Bool;
	public var beatTheWizard:Bool;
	public var seenPrincexx:Bool;
	public var endedTheMonarchy:Bool;
	public var towerOwner_Mage:Bool;
	public var towerOwner_Warlord:Bool;
	
	// Temporary stats
	public var money:Int;
	public var reputation:Int;
	public var grade:Int;
	public var shelter:Int;
	public var weaponmelee:Int;
	public var weaponmagic:Int;
	public var vehicle:Int;
	public var gift:Int;
	public var tower:Int;

	public var royal:Bool;
	public var monarch:Bool;
	public var horseFriend:Bool;
	
	public function reset()
	{
		year = 13;
		season = 0;
		
		health = 5;
		strength = 0;
		wisdom = 0;
		charisma = 0;
		magic = 0;
		warfare = 0;
		cursed = true;

		ui = 0;
		ui_hide_shop = 0;
		mysticProgress = 0;
		totalAdventures = 0;
		killedTheBear = false;
		foundWizardTower = false;
		beatTheWizard = false;
		seenPrincexx = false;
		endedTheMonarchy = false;
	
		resetyear();
	}
	
	public function resetyear()
	{
		money = 0;
		reputation = 0;
		grade = 0;
		shelter = 0;
		weaponmelee = 0;
		weaponmagic = 0;
		vehicle = 0;
		gift = 0;
		royal = false;
		monarch = false;
		tower = 0;
		horseFriend = false;
	}
	
	public static function get()
	{
		if (session == null)
		{
			session = new GameSession();
		}
		
		return session;
	}

	public function new() 
	{
		reset();
	}
	
	static var session:GameSession = null;
}