package;

import haxegon.*;

class SituationNewSeason extends Situation
{
	static inline var animFramesIn:Int = 65;
	static inline var animFramesOut:Int = 50;
	
	var season:Int;
	var animationFrame:Int;
	
	public function new(_season:Int) 
	{
		super();
		
		season = _season;
		animationFrame = 0;
	}
	
	public override function update()
	{
		++animationFrame;
	}

	public override function render()
	{
		var seasonName:String = "";
		switch (season)
		{
			case 0: seasonName = "Spring";
			case 1: seasonName = "Summer";
			case 2: seasonName = "Autumn";
			case 3: seasonName = "Winter";
		}

		Text.setfont("gamjaflower-regular", 60);
		
		var textX:Int = Std.int(Gfx.screenwidthmid - 0.5*Text.width(seasonName));
		var textY:Int = Gfx.screenheightmid - 50;
		
		if (animationFrame < animFramesIn)
		{
			var offset:Float = (animFramesIn - animationFrame) / animFramesIn;
			textX += Std.int(Gfx.screenwidth * Math.pow(offset, 4));
		}
		else
		{
			var offset:Float = (animationFrame - animFramesIn) / animFramesOut;
			textX -= Std.int(Gfx.screenwidth * Math.pow(offset, 5));
		}
		
		Text.display(textX+2, textY+2, seasonName, Colors.TEXT_LIGHT_BG);
		Text.display(textX-1, textY-1, seasonName, Colors.TEXT_LIGHT_BG);
		Text.display(textX, textY, seasonName, Colors.TEXT_LIGHT_FG);
		
		//CustomText.render(Gfx.screenwidthmid, Gfx.screenheightmid, seasonName);
	}
	
	public override function isComplete() : Bool
	{
		return animationFrame >= animFramesIn + animFramesOut;
	}
}