package;

import openfl.Lib;
import haxegon.*;

class TitleScene 
{
	var scenetime:Float = 0;
	
	static var achievements:Int = 0;
	static var achievementList:Array<String> = ["Champion", "Horse", "Evil Overlord", "Bearly Survived", "Republican", "Monarch", "Homeowner", "Fortunate Cure", "Did The Research"];
	static var achievementGot:Array<Bool> = [false, false, false, false, false, false, false, false, false];
	
	public static function achieve(_achievement:String)
	{
		var total:Int = 0;
		
		for (i in 0 ... achievementList.length)
		{
			if (achievementList[i] == _achievement)
			{
				achievementGot[i] = true;
			}
			
			if (achievementGot[i]) {
				++total;
			}
		}
		
		achievements = total;
	}
	
	
	function init() 
	{
		
	}

	function reset()
	{
		scenetime = 0;
	}
	
	function update() 
	{
		scenetime += 1 / 60;
		
		if (Mouse.leftclick())
		{
			Scene.restart(GameScene);
			Scene.change(GameScene);
		}
	}
	
	function drawAchievement(_idx:Int, _x:Int, _y:Int)
	{
		var text:String = achievementList[_idx];
		var got:Bool = achievementGot[_idx];
		
		var textX:Int = _x - Std.int(0.5 * CustomText.width(text));
		
		if (got)
		{
			CustomText.render(textX, _y, text, 0);
		}
		else
		{
			CustomText.render(textX, _y, text, 1);
		}
	}
	
	function render()
	{
		GameScene.renderPlaza(scenetime, false);
		
		Text.setfont("gamjaflower-regular", 30);
		
		var text1:String = "All I Got For My Birthday Was This";
		var textX:Int = Std.int(Gfx.screenwidthmid - 0.5*Text.width(text1));
		var textY:Int = 63;
		Text.display(textX+2, textY+2, text1, Colors.TEXT_LIGHT_BG);
		//Text.display(textX-1, textY-1, text1, Colors.TEXT_LIGHT_BG);
		Text.display(textX, textY, text1, Colors.TEXT_LIGHT_FG);
		
		Text.setfont("gamjaflower-regular", 80);
		
		var text2:String = "Terrible Curse";
		var textX:Int = Std.int(Gfx.screenwidthmid - 0.5*Text.width(text2));
		var textY:Int = 85;
		Text.display(textX+2, textY+2, text2, Colors.TEXT_LIGHT_BG);
		//Text.display(textX-1, textY-1, text2, Colors.TEXT_LIGHT_BG);
		Text.display(textX, textY, text2, Colors.TEXT_LIGHT_FG);
		
		if (achievements > 0)
		{
			if ((Lib.getTimer() % 1200) < 600)
			{
				CustomText.render(Std.int(Gfx.screenwidthmid - 0.5 * CustomText.width("Click to start")), 180, "Click to start", 3);
			}
			
			CustomText.render(Std.int(Gfx.screenwidthmid - 0.5 * CustomText.width("Achievements")), 240, "Achievements", 0);
			drawAchievement(0, 180, 270);
			drawAchievement(1, 320, 270);
			drawAchievement(2, 460, 270);
			
			drawAchievement(3, 180, 290);
			drawAchievement(4, 320, 290);
			drawAchievement(5, 460, 290);
			
			drawAchievement(6, 180, 310);
			drawAchievement(7, 320, 310);
			drawAchievement(8, 460, 310);
		}
		else
		{
			if ((Lib.getTimer() % 1200) < 600)
			{
				CustomText.render(Std.int(Gfx.screenwidthmid - 0.5 * CustomText.width("Click to start")), 230, "Click to start", 3);
			}
		}
	}
}